* IT.PRG

#INCLUDE "FOXPRO.H"

*
* "talk" status is a special case
*
if set("talk") == "ON"
 set talk off
 m.gcOldTalk = "ON"
else
 m.gcOldTalk = "OFF"
endif

m.gnTimeBegin  = seco()
m.glWeAreDone = .F.

*
* structure is
*  BORG
*    SOURCE
*    MDFILES
*    APPFILES
*    DATA1
*    DATA2
*
*  COMMON and THIRD are anywhere
*
* we started either in BORG or in BORG\SOURCE
*

*
* for the purposes of this sample, all COMMON code is 
* in the SOURCE directory (classes, proc files, etc.)
*

*
* save the Directory that was the default at the start of this program
* it's either something like
*  "f:\borg\source" (for developing) or
*  "f:\borg" (for production)
*
m.gcDefAtProgStart = sys(5) + sys(2003) && Default at Program Startup

*
* save the FoxPro path that was in effect at the start of this program
* if it exists, it's probably "e:\common30, e:\third30, e:\dev30"
*
m.gcPathAtProgStart = set("path") && FoxPro path at Program Startup 

*
* get the INI file that tells us where everything is
*
* also, set the path (assuming the above dir structure)
*
* create a new path string that consists of:
*  the Default Directory at Prog Start
*  the existing path
*  the location of metdata files
*  the location of application specific files
*
*  this will need to be modified for the location of customer common and thirdparty
*   (developer common and thirdparty will be found in the existing path)
*

*
* m.gcCurPathB is the path before we set the data dir
*

sele 0
if uppe(right(m.gcDefAtProgStart,6)) = "SOURCE"
 * assuming MDFILES is "next door"
 if file(left(m.gcDefAtProgStart, len(m.gcDefAtProgStart) - 6) + "MDFILES\IT.INI")
  m.gcLocIni = left(m.gcDefAtProgStart, len(m.gcDefAtProgStart) - 6) + "MDFILES\IT.INI"
  m.gcPathB4 = gcDefAtProgStart ;
   + iif(!empt(m.gcPathAtProgStart), "; "+m.gcPathAtProgStart, "") ;
   + "; ..\MDFILES" ;
   + "; ..\APPFILES"  
 else
  wait wind left(m.gcDefAtProgStart, len(m.gcDefAtProgStart) - 6) + "MDFILES\IT.INI" + " does not exist"
  m.glWeAreDone = .T.
 endi
else 
 * assuming MDFILES is "down below"
 if file(m.gcDefAtProgStart + "\MDFILES\IT.INI")
  m.gcLocIni = m.gcDefAtProgStart + "\MDFILES\IT.INI"
  m.gcPathB4 = gcDefAtProgStart ;
   + iif(!empt(m.gcPathAtProgStart), "; "+m.gcPathAtProgStart, "") ;
   + "; MDFILES" ;
   + "; APPFILES"  
 else
  wait wind m.gcDefAtProgStart + "\MDFILES\IT.INI" + " does not exist"
  m.glWeAreDone = .T.
 endi
endi

*
* now set path to this new string
*
set path to &gcPathB4

*
* find COMMON from our INI file
*
* create a cursor to hold the whole INI file
* and then look for the location of COMMON
*
* note that IT.INI is now in our path
*
create cursor csrFiLoc ;
 (cJunk C(100))
 
append from IT.INI sdf
loca for "cLocCommon" $ cJunk
if !eof()

 m.cPathComm = allt(subs( cJunk, at("=", cJunk) + 1))
 
 m.gcPathB4 = m.cPathComm ;
  + iif(empt(m.gcPathB4), "", ";") ;
  + m.gcPathB4

 *
 * set path again to include COMMON
 *
 set path to &gcPathB4

endif

m.gcOldClas = set("classlib")
close all
set classlib to BASEAPP, BASETBR
oEnv = createobject("ENV")

*
* clean out everything
*
oEnv.CleanOut()

*
* save current environment
*
oEnv.SaveSets()

*
* do environment and configuration check
*
oEnv.EnvCheck()

oApp = createobject("APP")

*
* initialize various system attributes
*
* readini will get the location of 
* the def data dir and add it to the path
*
oApp.ReadIni()


*
* accepting user logins with the appropriate security
*
oApp.Login()

if !oApp.lWeAreDone
 *
 * define environment - we do this now because
 * the environment may change according to 
 * who the user is!
 *
 oEnv.DoSets()

 *
 * change to the default directory
 *
 oApp.SetFileLocs()

 *
 * set up screen, menu, and event handler
 *
 oApp.it()

 *
 * return the environment to the way it was
 *
 oEnv.RestoreSets

endif

*
* clean out rest of app
*
oEnv.ShutDown()

do case
case oEnv.cTypeExit = "VFP"
 rele oEnv
 clea all
 wait wind nowa "See ya later, alligator"
 return
case oEnv.cTypeExit = "OS"
 rele oEnv
 clea all
 @2,0 say "See you next time"
 quit
endcase


* <EOF>
